
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 81
#define YY_END_OF_BUFFER 82
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[387] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   82,   80,   79,   79,   80,   80,   80,   34,
       55,   80,   80,   80,   80,   60,   80,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   35,   36,   54,   79,
       55,   80,   80,   80,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   72,   71,   71,   72,   72,   61,
       72,   63,   62,   69,   69,   69,   43,   43,   42,   41,
       40,   33,   31,   31,   33,   33,   33,    9,   33,   12,
       13,    7,   10,    6,   11,    8,   27,   27,   19,   33,
       20,   32,   32,   32,   32,   32,   32,   32,    0,    0,

       78,    0,    0,   59,   59,   59,   57,   65,   60,    0,
       60,   60,   60,    1,   60,   60,   60,   60,   60,   60,
        0,    0,    0,    0,    0,    0,    0,    0,   59,    0,
        0,    0,   60,   60,   60,   60,   60,   60,    1,   60,
       60,   60,   60,   60,   60,    0,   64,    0,    0,   70,
       66,   62,   69,   69,   68,   44,   40,   17,    0,   30,
        0,    0,   28,    0,   29,    0,   67,   25,    0,   27,
       15,   18,   14,   16,   32,   32,   32,   32,    3,   32,
       32,    0,   74,    0,   73,    0,    0,   76,    0,   59,
       59,   56,   56,   57,   58,   60,   60,   60,   60,   60,

       60,   60,   60,   60,   60,   53,    0,   77,   59,    0,
        0,   53,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,    0,    0,    0,   28,    0,    0,   26,    4,
       32,    5,   32,   32,    0,   75,   59,   56,   56,   58,
       60,   60,   60,   60,   60,   60,   60,   60,   38,   60,
        0,    0,    0,   60,   60,   60,   60,   60,   60,   60,
       60,   38,   60,    0,    0,    0,    0,    0,   32,   32,
        2,   60,   60,   60,   60,   60,   60,   60,   60,   60,
        0,    0,   60,   60,   60,   60,   60,   60,   60,   60,
       60,    0,   32,   32,   60,   60,   60,    0,   49,   60,

       60,   60,   60,   60,    0,    0,   60,   60,   60,   60,
       60,   60,   60,   60,   32,   32,    0,   51,   60,    0,
       45,    0,   50,   60,   60,   37,   60,    0,   52,   60,
       60,   60,   37,   60,   32,   32,   60,   60,   60,   60,
       60,   60,   60,   60,   21,   32,    0,   48,   60,    0,
       47,    0,   46,   60,   32,   32,   60,   60,   22,   23,
       60,   60,   32,   60,   60,   24,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   39,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   39,   40,   41,   42,   43,   44,
       39,   45,   46,   47,   48,   49,   50,   51,   52,   39,
        1,   53,    1,   29,   54,    1,   55,   56,   57,   58,

       59,   60,   61,   62,   63,   39,   39,   64,   65,   66,
       67,   68,   39,   69,   70,   71,   72,   49,   73,   74,
       75,   39,   76,   29,   77,   78,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[79] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,    1,   13,
       13,   14,   15,   16,    1,   17,    1,   18,    1,   19,
       20,   21,   21,   21,   19,   22,   22,   22,   22,   22,
       22,   23,   22,   22,   23,   22,   23,   22,   24,   22,
       25,   22,    6,   26,   19,   20,   21,   21,   21,   19,
       22,   22,   22,   22,   22,   23,   22,   22,   23,   22,
       23,   22,   22,   25,   22,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[453] =
    {   0,
        0,   78,  156,    0,  232,  233,  235,  238,  230,  235,
      257,    0, 1149, 2817, 2817, 2817,    0, 1126,    0, 2817,
     2817, 1089,  230,    0, 1087,    0,    0,  304,  295,  299,
      305,  299,  298,  296,  298,  314, 2817, 2817,    0,  355,
      333, 1084,  378,  391,  443,  419,  487,  334,  382,  309,
      377,  378,  380,  419, 2817, 2817, 2817,  375, 1088, 2817,
     1074, 2817,    0, 1041,  998,  978,    0, 2817, 2817, 2817,
      394, 2817, 2817, 2817,  968,  413,  350, 2817,  385, 2817,
     2817, 2817, 2817, 2817, 2817,  973,  448,  450,  227,  925,
      916,  410,    0,  431,  439,  443,  442,  313,  477,  910,

     2817,  554,  488,    0,  512,  415,    0, 2817,    0,  794,
      446,  452,  453,    0,  466,  488,  599,  483,  481,  484,
      527,  517,  792,  769,  618,    0,  625,  645,  666,  733,
      524,  640,  682,  634,  707,  748,  641,  659,  480,  642,
      700,  733,  710,  668,  708,  424, 2817,  389,  734, 2817,
     2817,    0,  702,  700, 2817,    0,  463, 2817,  631, 2817,
      731,    0,    0,  687, 2817,  733, 2817,  532,    0,  696,
     2817, 2817, 2817, 2817,    0,  607,  672,  685,    0,  679,
      726,  784, 2817,  661, 2817,  819,  787,  794,  632,  806,
      536,    0,    0,    0,    0,  740,  713,  762,  727,  850,

      855,  856,  867,  859,  860,    0,  812, 2817,  903,  898,
      741,  903,  944,  994,  884,  863,  864,  899,  902,  885,
      903,  906,  969,  791,    0,    0,  917,    0, 2817,    0,
      885,    0,  894,  911,  533, 2817,  523,    0,    0,    0,
      935,  932,  886,  933,  941,  948,  954,  949,    0,  956,
      979,  981, 1019,  982,  980,  991,  983,  992,  988, 1009,
      990,  993, 1001, 1053,  971,    0,  979,    0,  976,  995,
        0, 1003, 1037, 1030, 1073, 1038, 1035, 1035, 1048, 1053,
     1077,  539, 1044, 1054, 1049, 1113, 1053, 1075, 1081, 1088,
     1098,  695, 1067, 1050, 1129, 1069, 1134, 1152, 2817, 1158,

     1108, 1092, 1096, 1101,  647,  481, 1172, 1127, 1175, 1178,
     1139, 1142, 1145, 1152, 1144,  287, 1199, 2817, 1148, 1202,
     2817, 1223, 2817, 1172,  289,    0, 1174,  394,  389, 1182,
     1195, 1188, 1174, 1197, 1190, 1199, 1247, 1201, 1266, 1269,
     1272, 1239, 1284, 1287,  302, 1232, 1302, 2817, 1243, 1308,
     2817, 1313, 2817, 1273, 1219, 1260, 1264, 1290,    0,  292,
     1268, 1281, 1263, 1290, 1293,    0, 1292, 1298, 1307, 1313,
     1296, 1304, 1304, 1319, 1314, 1332, 1330, 1338, 1337, 1341,
     1332, 1335,  233, 1336, 2817, 2817, 1411, 1437, 1463, 1489,
     1515, 1523, 1548, 1574, 1592, 1606, 1630, 1648, 1666, 1691,

     1711, 1729, 1755, 1781, 1796, 1822, 1848, 1874, 1896, 1921,
     1935, 1961, 1987, 2007, 2028, 2053, 2076, 2097, 2116, 2142,
     2163, 2187, 2202, 2228, 2254, 2280, 2301, 2308, 2323, 2349,
     2370, 2383, 2392, 2418, 2444, 2470, 2496, 2522, 2548, 2574,
     2600, 2618, 2640, 2662, 2683, 2702, 2728, 2742, 2751, 2760,
     2769, 2790
    } ;

static yyconst flex_int16_t yy_def[453] =
    {   0,
      386,  386,  386,    3,  387,  387,  388,  388,  389,  389,
      386,   11,  386,  386,  386,  386,  390,  391,  392,  386,
      386,  386,  393,  393,  394,  395,  396,  395,  395,  395,
      395,  395,  395,  395,  395,  395,  386,  386,  393,  397,
      398,  399,  400,  401,  402,  402,  402,   47,   47,   47,
       47,   47,   47,   47,  386,  386,  386,  403,  404,  386,
      386,  386,  405,  406,  406,  386,  407,  386,  386,  386,
      386,  386,  386,  386,  386,  408,  409,  386,  410,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  411,  411,  411,  411,  411,  411,  411,  390,  391,

      386,  386,  386,  393,  393,  412,  413,  386,  395,  396,
      395,  395,  395,  395,  395,  395,  395,  395,  395,  395,
      397,  398,  399,  414,  398,  415,  386,  399,  416,  414,
      414,  417,  418,  395,  419,  419,  136,  136,  136,  136,
      136,  136,  136,  136,  136,  420,  386,  421,  422,  386,
      386,  423,  424,  424,  386,  425,  386,  386,  426,  386,
      427,  428,  429,  430,  386,  431,  386,  386,  432,  386,
      386,  386,  386,  386,  433,  433,  433,  433,  433,  433,
      433,  386,  386,  434,  386,  386,  386,  386,  435,  436,
      437,  438,  439,  440,  441,  442,  442,  442,  442,  442,

      442,  442,  442,  442,  442,  443,  386,  386,  436,  386,
      444,  445,  446,  446,  214,  214,  214,  214,  214,  214,
      214,  214,  447,  386,  448,  429,  386,  449,  386,  433,
      433,  433,  433,  433,  435,  386,  437,  438,  439,  441,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      444,  444,  444,  214,  214,  214,  214,  214,  214,  214,
      214,  214,  214,  447,  386,  450,  386,  451,  433,  433,
      433,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      386,  386,  214,  214,  214,  214,  214,  214,  214,  214,
      214,  447,  433,  433,  442,  442,  442,  386,  386,  442,

      442,  442,  442,  442,  386,  452,  214,  214,  214,  214,
      214,  214,  214,  214,  433,  433,  386,  386,  442,  386,
      386,  386,  386,  442,  442,  442,  442,  452,  452,  214,
      214,  214,  214,  214,  433,  433,  442,  442,  442,  442,
      214,  214,  214,  214,  433,  433,  386,  386,  442,  386,
      386,  386,  386,  214,  433,  433,  442,  214,  433,  433,
      442,  214,  433,  442,  214,  433,  442,  214,  442,  214,
      442,  214,  442,  214,  442,  214,  442,  214,  442,  214,
      442,  214,  442,  214,  386,    0,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,

      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386
    } ;

static yyconst flex_int16_t yy_nxt[2896] =
    {   0,
       14,   15,   16,   15,   17,   14,   18,   19,   14,   20,
       14,   14,   14,   21,   22,   14,   23,   24,   25,   26,
       26,   26,   27,   14,   14,   14,   24,   24,   24,   28,
       26,   29,   26,   26,   26,   30,   26,   31,   26,   26,
       32,   26,   26,   33,   34,   35,   36,   26,   26,   26,
       26,   26,   14,   26,   28,   26,   29,   26,   26,   26,
       30,   26,   31,   26,   32,   26,   26,   33,   34,   35,
       36,   26,   26,   26,   26,   37,   38,   39,   14,   40,
       16,   40,   17,   14,   18,   19,   14,   20,   14,   14,
       14,   41,   42,   14,   43,   24,   25,   26,   26,   26,

       44,   14,   14,   14,   24,   24,   24,   45,   46,   47,
       46,   46,   46,   48,   46,   49,   46,   46,   50,   46,
       46,   51,   52,   53,   54,   46,   46,   46,   46,   46,
       14,   26,   45,   46,   47,   46,   46,   46,   48,   46,
       49,   46,   50,   46,   46,   51,   52,   53,   54,   46,
       46,   46,   46,   37,   38,   39,   55,   56,   57,   56,
       55,   58,   59,   55,   55,   55,   55,   55,   60,   55,
       55,   55,   55,   55,   61,   55,   55,   55,   55,   55,
       55,   62,   55,   55,   55,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,

       63,   63,   63,   63,   63,   63,   63,   63,   55,   55,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   55,   55,   55,   65,   65,   68,   68,   68,   68,
       68,   68,   70,  105,  385,   66,   66,   70,  106,   71,
       71,   71,  171,  172,   71,   71,   71,   72,   73,   74,
       73,   75,   76,   72,   77,   78,   72,   79,   80,   81,
       82,   83,   84,   85,   72,   86,   87,   88,   88,   72,
       72,   89,   90,   91,   72,   72,   92,   93,   94,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   95,   96,

       93,   93,   97,   98,   93,   93,   93,   93,   93,   72,
       72,   92,   93,   94,   93,   93,   93,   93,   93,   93,
       93,   93,   95,   96,   93,   93,   97,   98,   93,   93,
       93,   93,   72,   72,   72,  111,  336,  112,  113,  114,
      339,  116,  117,  118,  119,  363,  115,  120,  126,  181,
      126,  141,  127,  127,  162,  355,  121,  162,  121,  336,
      111,  112,  113,  339,  114,  116,  117,  118,  119,  123,
      115,  123,  120,  138,  181,  141,  135,  124,  104,  104,
      147,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  105,  104,  104,  329,  165,  106,  138,  130,  329,

      135,  104,  104,  104,  104,  104,  104,  131,  223,  223,
      110,  110,  110,  157,  157,  157,  139,  193,  160,  135,
      135,  142,  135,  140,  135,  143,  144,  148,  104,  147,
      104,  104,  125,  109,  133,  109,  126,  166,  134,  134,
      109,  139,  109,  135,  135,  142,  135,  140,  135,  143,
      144,  176,  145,  104,  104,  104,  125,  109,  133,  109,
      126,  135,  134,  134,  109,  161,  109,  168,  168,  170,
      170,  170,  109,  177,  136,  176,  148,  145,  182,  183,
      182,  178,  157,  157,  157,  135,  329,  179,  180,  187,
      188,  187,  196,  197,  189,  198,  109,  177,  169,  136,

      125,  109,  133,  109,  126,  178,  134,  134,  109,  199,
      109,  179,  180,  190,  188,  190,  196,  197,  191,  198,
      200,  169,  203,  204,  205,  236,  135,  210,  121,  137,
      121,  386,  126,  199,  126,  236,  127,  127,  236,  211,
      109,  123,  305,  123,  306,  200,  203,  204,  205,  124,
      135,  168,  168,  137,  184,  184,  185,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,

      186,  186,  186,  186,  186,  186,  184,  184,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  184,
      184,  184,  201,  126,  236,  126,  160,  127,  127,  230,
      126,  202,  126,  210,  127,  127,  207,  208,  207,  133,
      305,  126,  306,  134,  134,  211,  131,  201,  386,  110,
      110,  110,  195,  185,  230,  202,  104,  209,  208,  209,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  214,  161,  104,  216,  206,  135,  135,  104,
      104,  104,  104,  104,  104,  206,  109,  165,  109,  206,

      147,  215,  154,  109,  154,  135,  214,  206,  233,  216,
      221,  135,  135,  231,  135,  170,  170,  170,  104,  104,
      125,  109,  133,  109,  126,  215,  134,  134,  109,  135,
      109,  232,  217,  233,  221,  109,  150,  231,  135,  166,
      386,  104,  104,  104,  251,  252,  135,  148,  222,  220,
      224,  224,  227,  227,  135,  232,  135,  217,  242,  234,
      109,  125,  109,  133,  109,  126,  218,  134,  134,  109,
      135,  109,  222,  220,  244,  219,  130,  241,  135,  135,
      135,  225,  242,  228,  234,  182,  183,  182,  187,  188,
      187,  218,  243,  189,  213,  187,  188,  187,  244,  219,

      189,  109,  241,  135,  225,  386,  228,  190,  188,  190,
      265,  265,  191,  207,  208,  207,  195,  243,  213,  184,
      184,  185,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  184,  184,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  184,  184,  184,  245,  246,  247,

      248,  210,  249,  250,  209,  208,  209,  206,  135,  135,
      257,  258,  101,  211,  256,  274,  206,  109,  261,  109,
      206,  245,  246,  247,  109,  248,  249,  250,  206,  135,
      135,  269,  135,  135,  257,  258,  267,  267,  270,  256,
      274,  174,  259,  261,  135,  260,  262,  135,  135,  263,
      173,  135,  271,  135,  135,  269,  109,  125,  109,  133,
      109,  126,  270,  134,  134,  109,  259,  109,  135,  260,
      262,  135,  135,  263,  147,  135,  271,  272,  273,  275,
      276,  254,  251,  252,  386,  386,  167,  278,  264,  264,
      159,  159,  277,  158,  279,  280,  155,  109,  164,  164,

      154,  272,  273,  275,  276,  293,  254,  125,  109,  133,
      109,  126,  278,  134,  134,  109,  277,  109,  279,  280,
      285,  148,  281,  386,  283,  135,  284,  135,  135,  286,
      293,  287,  288,  135,  282,  290,  135,  135,  135,  255,
      291,  294,  289,  154,  295,  285,  135,  109,  283,  135,
      284,  135,  135,  286,  135,  287,  288,  135,  147,  290,
      135,  135,  135,  255,  291,  294,  296,  289,  295,  297,
      135,  300,  292,  292,  298,  298,  298,  301,  135,  302,
      281,  303,  304,  308,  299,  307,  310,  151,  309,  135,
      150,  296,  282,  297,  135,  316,  300,  103,  135,  135,

      108,  301,  103,  302,  315,  148,  303,  304,  308,  307,
      319,  310,  309,  135,  298,  298,  298,  311,  135,  316,
      135,  313,  135,  135,  299,  312,  135,  314,  101,  315,
      317,  317,  317,  135,  319,  320,  320,  320,  325,  324,
      318,  311,  326,  135,  135,  321,  313,  327,  386,  312,
      135,  386,  314,  298,  298,  298,  386,  135,  135,  322,
      322,  322,  325,  299,  324,  386,  326,  135,  330,  323,
      331,  327,  135,  317,  317,  317,  320,  320,  320,  322,
      322,  322,  135,  318,  135,  335,  321,  135,  332,  323,
      135,  333,  330,  386,  337,  331,  135,  135,  334,  386,

      317,  317,  317,  320,  320,  320,  338,  340,  135,  335,
      318,  135,  332,  321,  135,  333,  386,  135,  337,  135,
      135,  135,  334,  135,  322,  322,  322,  135,  341,  342,
      344,  338,  340,  135,  323,  345,  346,  386,  349,  343,
      135,  135,  135,  135,  135,  386,  386,  135,  347,  347,
      347,  135,  341,  386,  342,  344,  359,  135,  348,  345,
      386,  346,  343,  349,  135,  386,  135,  350,  350,  350,
      352,  352,  352,  347,  347,  347,  354,  351,  356,  386,
      353,  359,  357,  348,  135,  350,  350,  350,  352,  352,
      352,  386,  386,  386,  386,  351,  360,  361,  353,  386,

      366,  354,  356,  347,  347,  347,  357,  364,  135,  350,
      350,  350,  358,  348,  352,  352,  352,  135,  135,  351,
      365,  360,  361,  362,  353,  366,  135,  367,  386,  135,
      368,  364,  135,  369,  386,  135,  358,  373,  135,  370,
      371,  135,  135,  135,  365,  374,  372,  385,  362,  135,
      135,  375,  367,  135,  377,  368,  135,  369,  135,  135,
      379,  373,  135,  370,  135,  371,  376,  135,  380,  374,
      381,  372,  378,  135,  382,  375,  383,  135,  377,  384,
      135,  135,  135,  135,  386,  379,  135,  386,  135,  386,
      376,  386,  386,  380,  386,  381,  378,  386,  386,  382,

      383,  135,  386,  384,  135,  135,  386,  135,  386,  386,
      135,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   99,
      386,  386,  386,   99,   99,   99,   99,   99,   99,   99,

       99,   99,   99,   99,   99,   99,   99,   99,   99,   99,
       99,   99,   99,   99,   99,  100,  100,  100,  100,  100,
      100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
      100,  100,  100,  100,  100,  100,  100,  100,  100,  100,
      100,  102,  102,  102,  102,  102,  102,  102,  104,  104,
      386,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  107,  107,  107,  107,  107,  107,

      109,  109,  109,  386,  109,  109,  386,  109,  386,  386,
      109,  109,  109,  109,  109,  109,  109,  109,  110,  110,
      386,  386,  386,  386,  110,  110,  110,  110,  110,  110,
      110,  122,  386,  122,  386,  386,  386,  122,  122,  386,
      122,  386,  386,  386,  122,  386,  386,  386,  122,  122,
      122,  122,  122,  122,  122,  125,  386,  125,  386,  125,
      125,  386,  386,  386,  386,  386,  125,  125,  125,  125,
      125,  125,  125,  128,  386,  386,  128,  128,  128,  128,
      128,  386,  386,  386,  128,  128,  128,  128,  128,  128,
      128,  129,  129,  386,  129,  129,  129,  129,  129,  129,

      129,  129,  129,  129,  129,  129,  129,  129,  129,  129,
      129,  129,  129,  129,  129,  129,  129,  132,  386,  386,
      386,  132,  386,  132,  132,  386,  386,  386,  386,  132,
      132,  132,  132,  132,  132,  132,  135,  135,  135,  135,
      135,  135,  135,  386,  135,  386,  386,  135,  135,  135,
      135,  135,  135,  135,  135,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  152,  152,  152,
      386,  386,  386,  386,  152,  152,  152,  152,  152,  152,
      152,  152,  153,  153,  153,  153,  153,  153,  153,  386,
      153,  153,  153,  153,  153,  153,  153,  153,  153,  153,
      153,  153,  153,  153,  153,  153,  153,  153,  156,  386,
      386,  386,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  159,  159,  159,  159,  159,  159,
      386,  159,  159,  159,  159,  159,  159,  159,  159,  159,
      159,  159,  159,  159,  159,  159,  159,  159,  159,  159,

      163,  386,  163,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  163,  163,  163,  163,  163,  163,
      163,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  175,  175,  386,
      386,  386,  386,  175,  175,  175,  175,  175,  175,  175,
      175,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  194,  194,  386,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,

      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  131,  386,  386,  386,  131,  386,  386,
      386,  386,  386,  386,  386,  131,  131,  131,  131,  131,
      131,  131,  206,  386,  386,  206,  386,  206,  386,  206,
      206,  386,  386,  206,  206,  386,  206,  206,  206,  206,
      206,  206,  206,  129,  129,  129,  129,  129,  129,  129,
      129,  129,  129,  129,  129,  129,  129,  129,  129,  129,
      129,  129,  129,  129,  129,  129,  129,  129,  129,  132,
      386,  386,  386,  386,  386,  132,  132,  386,  132,  132,
      132,  386,  386,  386,  132,  132,  132,  132,  132,  132,

      132,  212,  386,  386,  212,  212,  212,  212,  212,  212,
      212,  386,  212,  212,  386,  212,  212,  212,  212,  212,
      212,  212,  212,  135,  135,  135,  135,  135,  135,  135,
      386,  135,  386,  386,  135,  135,  135,  135,  135,  135,
      135,  135,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  386,
      386,  386,  386,  386,  386,  146,  386,  386,  386,  386,
      146,  146,  146,  386,  386,  146,  146,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  152,  152,  152,  386,  386,  386,  386,
      152,  152,  152,  152,  152,  152,  152,  152,  153,  153,
      153,  153,  153,  153,  153,  386,  153,  153,  153,  153,
      153,  153,  153,  153,  153,  153,  153,  153,  153,  153,
      153,  153,  153,  153,  156,  386,  386,  386,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  156,
      159,  159,  159,  159,  159,  159,  386,  159,  159,  159,
      159,  159,  159,  159,  159,  159,  159,  159,  159,  159,

      159,  159,  159,  159,  159,  159,  159,  159,  386,  386,
      386,  386,  386,  159,  386,  386,  386,  386,  386,  386,
      159,  386,  386,  159,  386,  159,  163,  163,  163,  163,
      163,  163,  163,  226,  226,  226,  226,  386,  386,  386,
      386,  226,  226,  226,  226,  226,  226,  226,  226,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  164,  164,  164,
      164,  164,  164,  164,  164,  164,  164,  386,  386,  386,
      386,  386,  164,  386,  386,  386,  386,  386,  386,  164,
      386,  386,  164,  386,  164,  229,  386,  386,  386,  386,

      386,  229,  229,  229,  175,  175,  386,  386,  386,  386,
      175,  175,  175,  175,  175,  175,  175,  175,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,
      184,  184,  184,  184,  235,  235,  235,  235,  235,  235,
      235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
      235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  104,  104,  104,  104,
      104,  104,  104,  104,  104,  104,  237,  237,  237,  237,

      237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
      237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
      237,  237,  238,  238,  386,  238,  238,  238,  238,  238,
      238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
      238,  238,  238,  238,  238,  238,  238,  238,  239,  239,
      386,  239,  239,  239,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
      239,  239,  239,  239,  194,  194,  386,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,

      240,  240,  386,  240,  240,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  109,  109,  109,  386,
      109,  109,  386,  109,  386,  386,  109,  109,  109,  109,
      109,  109,  109,  109,  206,  386,  386,  206,  386,  206,
      386,  206,  206,  386,  386,  206,  206,  386,  206,  206,
      206,  206,  206,  206,  206,  253,  253,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      253,  253,  253,  253,  253,  253,  253,  212,  386,  386,
      212,  212,  212,  212,  212,  212,  212,  386,  212,  212,

      386,  212,  212,  212,  212,  212,  212,  212,  212,  135,
      135,  135,  135,  135,  135,  135,  386,  135,  386,  386,
      135,  135,  135,  135,  135,  135,  135,  135,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  266,  266,  386,  386,  386,  386,
      266,  266,  266,  268,  268,  386,  386,  386,  386,  268,
      268,  268,  159,  159,  386,  386,  386,  386,  159,  159,
      159,  164,  164,  386,  386,  386,  386,  164,  164,  164,
      328,  328,  386,  328,  328,  328,  328,  328,  328,  328,

      328,  328,  328,  328,  328,  328,  328,  328,  328,  328,
      328,  328,  328,  328,  328,  328,   13,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386

    } ;

static yyconst flex_int16_t yy_chk[2896] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    5,    6,    7,    7,    7,    8,
        8,    8,    9,   23,  383,    5,    6,   10,   23,    9,
        9,    9,   89,   89,   10,   10,   10,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   28,  316,   29,   30,   31,
      325,   32,   33,   34,   35,  360,   31,   36,   41,   98,
       41,   50,   41,   41,   77,  345,   40,   77,   40,  316,
       28,   29,   30,  325,   31,   32,   33,   34,   35,   40,
       31,   40,   36,   48,   98,   50,   48,   40,   43,   43,
       58,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   43,   43,  329,   79,   43,   48,   44,  328,

       48,   43,   43,   43,   43,   43,   43,   44,  148,  148,
       44,   44,   44,   71,   71,   71,   49,  106,   76,   51,
       52,   51,   53,   49,   49,   52,   53,   58,  106,  146,
       43,   43,   46,   46,   46,   46,   46,   79,   46,   46,
       46,   49,   46,   51,   52,   51,   53,   49,   49,   52,
       53,   92,   54,   43,   43,   43,   45,   45,   45,   45,
       45,   54,   45,   45,   45,   76,   45,   87,   87,   88,
       88,   88,   46,   94,   45,   92,  146,   54,   99,   99,
       99,   95,  157,  157,  157,   54,  306,   96,   97,  103,
      103,  103,  111,  112,  103,  113,   45,   94,   87,   45,

       47,   47,   47,   47,   47,   95,   47,   47,   47,  115,
       47,   96,   97,  105,  105,  105,  111,  112,  105,  113,
      116,   87,  118,  119,  120,  237,  139,  131,  121,   47,
      121,  131,  122,  115,  122,  235,  122,  122,  191,  131,
       47,  121,  282,  121,  282,  116,  118,  119,  120,  121,
      139,  168,  168,   47,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,

      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  102,  102,  102,  102,  102,  102,  102,  102,
      102,  102,  117,  125,  189,  125,  159,  125,  125,  176,
      127,  117,  127,  132,  127,  127,  128,  128,  128,  134,
      305,  134,  305,  134,  134,  132,  132,  117,  128,  132,
      132,  132,  132,  184,  176,  117,  129,  129,  129,  129,
      129,  129,  129,  129,  129,  129,  129,  129,  129,  129,
      129,  129,  137,  159,  129,  140,  133,  137,  140,  129,
      129,  129,  129,  129,  129,  133,  133,  164,  133,  133,

      292,  138,  154,  133,  153,  138,  137,  133,  180,  140,
      144,  137,  140,  177,  144,  170,  170,  170,  129,  129,
      135,  135,  135,  135,  135,  138,  135,  135,  135,  138,
      135,  178,  141,  180,  144,  133,  149,  177,  144,  164,
      130,  129,  129,  129,  211,  211,  141,  292,  145,  143,
      161,  161,  166,  166,  145,  178,  143,  141,  197,  181,
      135,  136,  136,  136,  136,  136,  142,  136,  136,  136,
      141,  136,  145,  143,  199,  142,  124,  196,  145,  142,
      143,  161,  197,  166,  181,  182,  182,  182,  187,  187,
      187,  142,  198,  187,  136,  188,  188,  188,  199,  142,

      188,  136,  196,  142,  161,  123,  166,  190,  190,  190,
      224,  224,  190,  207,  207,  207,  110,  198,  136,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  186,  200,  201,  202,

      203,  210,  204,  205,  209,  209,  209,  212,  216,  217,
      216,  217,  100,  210,  215,  243,  212,  212,  220,  212,
      212,  200,  201,  202,  212,  203,  204,  205,  212,  215,
      220,  231,  216,  217,  216,  217,  227,  227,  233,  215,
      243,   91,  218,  220,  218,  219,  221,  219,  221,  222,
       90,  222,  234,  215,  220,  231,  212,  213,  213,  213,
      213,  213,  233,  213,  213,  213,  218,  213,  218,  219,
      221,  219,  221,  222,  223,  222,  234,  241,  242,  244,
      245,  213,  251,  251,  252,  252,   86,  247,  223,  223,
      265,  265,  246,   75,  248,  250,   66,  213,  267,  267,

       65,  241,  242,  244,  245,  269,  213,  214,  214,  214,
      214,  214,  247,  214,  214,  214,  246,  214,  248,  250,
      256,  223,  253,  253,  254,  255,  255,  254,  257,  257,
      269,  258,  259,  259,  253,  261,  256,  258,  262,  214,
      263,  270,  260,   64,  272,  256,  263,  214,  254,  255,
      255,  254,  257,  257,  260,  258,  259,  259,  264,  261,
      256,  258,  262,  214,  263,  270,  273,  260,  272,  274,
      263,  276,  264,  264,  275,  275,  275,  277,  260,  278,
      281,  279,  280,  284,  275,  283,  287,   61,  285,  283,
       59,  273,  281,  274,  285,  294,  276,   42,  287,  284,

       25,  277,   22,  278,  293,  264,  279,  280,  284,  283,
      296,  287,  285,  283,  286,  286,  286,  288,  285,  294,
      288,  290,  287,  284,  286,  289,  289,  291,   18,  293,
      295,  295,  295,  290,  296,  297,  297,  297,  302,  301,
      295,  288,  303,  291,  288,  297,  290,  304,   13,  289,
      289,    0,  291,  298,  298,  298,    0,  290,  286,  300,
      300,  300,  302,  298,  301,    0,  303,  291,  308,  300,
      311,  304,  308,  307,  307,  307,  309,  309,  309,  310,
      310,  310,  286,  307,  311,  315,  309,  312,  312,  310,
      313,  313,  308,    0,  319,  311,  308,  314,  314,    0,

      317,  317,  317,  320,  320,  320,  324,  327,  311,  315,
      317,  312,  312,  320,  313,  313,    0,  307,  319,  333,
      309,  314,  314,  310,  322,  322,  322,  330,  330,  331,
      334,  324,  327,  332,  322,  335,  336,    0,  338,  332,
      331,  307,  334,  333,  309,    0,    0,  310,  337,  337,
      337,  330,  330,    0,  331,  334,  355,  332,  337,  335,
        0,  336,  332,  338,  331,    0,  334,  339,  339,  339,
      340,  340,  340,  341,  341,  341,  342,  339,  346,    0,
      340,  355,  349,  341,  342,  343,  343,  343,  344,  344,
      344,    0,    0,    0,    0,  343,  356,  357,  344,    0,

      363,  342,  346,  347,  347,  347,  349,  361,  342,  350,
      350,  350,  354,  347,  352,  352,  352,  341,  354,  350,
      362,  356,  357,  358,  352,  363,  362,  364,    0,  343,
      365,  361,  344,  367,    0,  358,  354,  371,  365,  368,
      369,  341,  354,  368,  362,  372,  370,  384,  358,  372,
      362,  373,  364,  343,  375,  365,  344,  367,  370,  358,
      377,  371,  365,  368,  374,  369,  374,  368,  378,  372,
      379,  370,  376,  372,  380,  373,  381,  376,  375,  382,
      382,  384,  370,  378,    0,  377,  380,    0,  374,    0,
      374,    0,    0,  378,    0,  379,  376,    0,    0,  380,

      381,  376,    0,  382,  382,  384,    0,  378,    0,    0,
      380,  387,  387,  387,  387,  387,  387,  387,  387,  387,
      387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
      387,  387,  387,  387,  387,  387,  387,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  388,  388,  388,  388,  388,  388,  388,
      388,  388,  388,  389,  389,  389,  389,  389,  389,  389,
      389,  389,  389,  389,  389,  389,  389,  389,  389,  389,
      389,  389,  389,  389,  389,  389,  389,  389,  389,  390,
        0,    0,    0,  390,  390,  390,  390,  390,  390,  390,

      390,  390,  390,  390,  390,  390,  390,  390,  390,  390,
      390,  390,  390,  390,  390,  391,  391,  391,  391,  391,
      391,  391,  391,  391,  391,  391,  391,  391,  391,  391,
      391,  391,  391,  391,  391,  391,  391,  391,  391,  391,
      391,  392,  392,  392,  392,  392,  392,  392,  393,  393,
        0,  393,  393,  393,  393,  393,  393,  393,  393,  393,
      393,  393,  393,  393,  393,  393,  393,  393,  393,  393,
      393,  393,  393,  393,  394,  394,  394,  394,  394,  394,
      394,  394,  394,  394,  394,  394,  394,  394,  394,  394,
      394,  394,  394,  394,  394,  394,  394,  394,  394,  394,

      395,  395,  395,    0,  395,  395,    0,  395,    0,    0,
      395,  395,  395,  395,  395,  395,  395,  395,  396,  396,
        0,    0,    0,    0,  396,  396,  396,  396,  396,  396,
      396,  397,    0,  397,    0,    0,    0,  397,  397,    0,
      397,    0,    0,    0,  397,    0,    0,    0,  397,  397,
      397,  397,  397,  397,  397,  398,    0,  398,    0,  398,
      398,    0,    0,    0,    0,    0,  398,  398,  398,  398,
      398,  398,  398,  399,    0,    0,  399,  399,  399,  399,
      399,    0,    0,    0,  399,  399,  399,  399,  399,  399,
      399,  400,  400,    0,  400,  400,  400,  400,  400,  400,

      400,  400,  400,  400,  400,  400,  400,  400,  400,  400,
      400,  400,  400,  400,  400,  400,  400,  401,    0,    0,
        0,  401,    0,  401,  401,    0,    0,    0,    0,  401,
      401,  401,  401,  401,  401,  401,  402,  402,  402,  402,
      402,  402,  402,    0,  402,    0,    0,  402,  402,  402,
      402,  402,  402,  402,  402,  403,  403,  403,  403,  403,
      403,  403,  403,  403,  403,  403,  403,  403,  403,  403,
      403,  403,  403,  403,  403,  403,  403,  403,  403,  403,
      403,  404,  404,  404,  404,  404,  404,  404,  404,  404,
      404,  404,  404,  404,  404,  404,  404,  404,  404,  404,

      404,  404,  404,  404,  404,  404,  404,  405,  405,  405,
        0,    0,    0,    0,  405,  405,  405,  405,  405,  405,
      405,  405,  406,  406,  406,  406,  406,  406,  406,    0,
      406,  406,  406,  406,  406,  406,  406,  406,  406,  406,
      406,  406,  406,  406,  406,  406,  406,  406,  407,    0,
        0,    0,  407,  407,  407,  407,  407,  407,  407,  407,
      407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
      407,  407,  407,  407,  408,  408,  408,  408,  408,  408,
        0,  408,  408,  408,  408,  408,  408,  408,  408,  408,
      408,  408,  408,  408,  408,  408,  408,  408,  408,  408,

      409,    0,  409,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,  409,  409,  409,  409,  409,  409,
      409,  410,  410,  410,  410,  410,  410,  410,  410,  410,
      410,  410,  410,  410,  410,  410,  410,  410,  410,  410,
      410,  410,  410,  410,  410,  410,  410,  411,  411,    0,
        0,    0,    0,  411,  411,  411,  411,  411,  411,  411,
      411,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  413,  413,    0,
      413,  413,  413,  413,  413,  413,  413,  413,  413,  413,

      413,  413,  413,  413,  413,  413,  413,  413,  413,  413,
      413,  413,  413,  414,    0,    0,    0,  414,    0,    0,
        0,    0,    0,    0,    0,  414,  414,  414,  414,  414,
      414,  414,  415,    0,    0,  415,    0,  415,    0,  415,
      415,    0,    0,  415,  415,    0,  415,  415,  415,  415,
      415,  415,  415,  416,  416,  416,  416,  416,  416,  416,
      416,  416,  416,  416,  416,  416,  416,  416,  416,  416,
      416,  416,  416,  416,  416,  416,  416,  416,  416,  417,
        0,    0,    0,    0,    0,  417,  417,    0,  417,  417,
      417,    0,    0,    0,  417,  417,  417,  417,  417,  417,

      417,  418,    0,    0,  418,  418,  418,  418,  418,  418,
      418,    0,  418,  418,    0,  418,  418,  418,  418,  418,
      418,  418,  418,  419,  419,  419,  419,  419,  419,  419,
        0,  419,    0,    0,  419,  419,  419,  419,  419,  419,
      419,  419,  420,  420,  420,  420,  420,  420,  420,  420,
      420,  420,  420,  420,  420,  420,  420,  420,  420,  420,
      420,  420,  420,  420,  420,  420,  420,  420,  421,    0,
        0,    0,    0,    0,    0,  421,    0,    0,    0,    0,
      421,  421,  421,    0,    0,  421,  421,  422,  422,  422,
      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,

      422,  422,  422,  422,  422,  422,  422,  422,  422,  422,
      422,  422,  422,  423,  423,  423,    0,    0,    0,    0,
      423,  423,  423,  423,  423,  423,  423,  423,  424,  424,
      424,  424,  424,  424,  424,    0,  424,  424,  424,  424,
      424,  424,  424,  424,  424,  424,  424,  424,  424,  424,
      424,  424,  424,  424,  425,    0,    0,    0,  425,  425,
      425,  425,  425,  425,  425,  425,  425,  425,  425,  425,
      425,  425,  425,  425,  425,  425,  425,  425,  425,  425,
      426,  426,  426,  426,  426,  426,    0,  426,  426,  426,
      426,  426,  426,  426,  426,  426,  426,  426,  426,  426,

      426,  426,  426,  426,  426,  426,  427,  427,    0,    0,
        0,    0,    0,  427,    0,    0,    0,    0,    0,    0,
      427,    0,    0,  427,    0,  427,  428,  428,  428,  428,
      428,  428,  428,  429,  429,  429,  429,    0,    0,    0,
        0,  429,  429,  429,  429,  429,  429,  429,  429,  430,
      430,  430,  430,  430,  430,  430,  430,  430,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  430,  430,  430,
      430,  430,  430,  430,  430,  431,  431,    0,    0,    0,
        0,    0,  431,    0,    0,    0,    0,    0,    0,  431,
        0,    0,  431,    0,  431,  432,    0,    0,    0,    0,

        0,  432,  432,  432,  433,  433,    0,    0,    0,    0,
      433,  433,  433,  433,  433,  433,  433,  433,  434,  434,
      434,  434,  434,  434,  434,  434,  434,  434,  434,  434,
      434,  434,  434,  434,  434,  434,  434,  434,  434,  434,
      434,  434,  434,  434,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      436,  436,  436,  436,  436,  436,  436,  436,  436,  436,
      436,  436,  436,  436,  436,  436,  436,  436,  436,  436,
      436,  436,  436,  436,  436,  436,  437,  437,  437,  437,

      437,  437,  437,  437,  437,  437,  437,  437,  437,  437,
      437,  437,  437,  437,  437,  437,  437,  437,  437,  437,
      437,  437,  438,  438,    0,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  438,  438,
      438,  438,  438,  438,  438,  438,  438,  438,  439,  439,
        0,  439,  439,  439,  439,  439,  439,  439,  439,  439,
      439,  439,  439,  439,  439,  439,  439,  439,  439,  439,
      439,  439,  439,  439,  440,  440,    0,  440,  440,  440,
      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,
      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,

      441,  441,    0,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  441,  441,  441,  441,
      441,  441,  441,  441,  441,  441,  442,  442,  442,    0,
      442,  442,    0,  442,    0,    0,  442,  442,  442,  442,
      442,  442,  442,  442,  443,    0,    0,  443,    0,  443,
        0,  443,  443,    0,    0,  443,  443,    0,  443,  443,
      443,  443,  443,  443,  443,  444,  444,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      444,  444,  444,  444,  444,  444,  444,  445,    0,    0,
      445,  445,  445,  445,  445,  445,  445,    0,  445,  445,

        0,  445,  445,  445,  445,  445,  445,  445,  445,  446,
      446,  446,  446,  446,  446,  446,    0,  446,    0,    0,
      446,  446,  446,  446,  446,  446,  446,  446,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  448,  448,    0,    0,    0,    0,
      448,  448,  448,  449,  449,    0,    0,    0,    0,  449,
      449,  449,  450,  450,    0,    0,    0,    0,  450,  450,
      450,  451,  451,    0,    0,    0,    0,  451,  451,  451,
      452,  452,    0,  452,  452,  452,  452,  452,  452,  452,

      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386,  386,  386,  386,  386,  386,
      386,  386,  386,  386,  386

    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[82] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 
    1, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 
    0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2012 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* The rsyslog runtime library is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* The rsyslog runtime library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with the rsyslog runtime library.  If not, see <http://www.gnu.org/licenses/>.
*
* A copy of the GPL can be found in the file "COPYING" in this distribution.
* A copy of the LGPL can be found in the file "COPYING.LESSER" in this distribution.
*/
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 61 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
//char *strdup(char*);
int fileno(FILE *stream);

#line 1351 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define EXPR 5

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 94 "lexer.l"


 /* keywords */
#line 1548 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 387 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 2817 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 97 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 98 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 99 "lexer.l"
{ return OR; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 100 "lexer.l"
{ return AND; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 101 "lexer.l"
{ return NOT; }
	YY_BREAK
case 6:
#line 103 "lexer.l"
case 7:
#line 104 "lexer.l"
case 8:
#line 105 "lexer.l"
case 9:
#line 106 "lexer.l"
case 10:
#line 107 "lexer.l"
case 11:
#line 108 "lexer.l"
case 12:
#line 109 "lexer.l"
case 13:
YY_RULE_SETUP
#line 109 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 110 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 111 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 112 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 17:
#line 114 "lexer.l"
case 18:
YY_RULE_SETUP
#line 114 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 115 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 116 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 117 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 118 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 119 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 120 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 25:
#line 122 "lexer.l"
case 26:
#line 123 "lexer.l"
case 27:
YY_RULE_SETUP
#line 123 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 124 "lexer.l"
{ yylval.s = strdup(yytext); return VAR; }
	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 125 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 30:
/* rule 30 can match eol */
YY_RULE_SETUP
#line 130 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 31:
/* rule 31 can match eol */
YY_RULE_SETUP
#line 135 "lexer.l"

	YY_BREAK
case 32:
YY_RULE_SETUP
#line 136 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 138 "lexer.l"
{ dbgprintf("invalid char in expr: %s\n", yytext); }
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 139 "lexer.l"
{ return '&'; }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 140 "lexer.l"
{ return '{'; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 141 "lexer.l"
{ return '}'; }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 142 "lexer.l"
{ dbgprintf("RULESET\n"); }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 38:
YY_RULE_SETUP
#line 146 "lexer.l"
{ dbgprintf("STOP\n"); return STOP; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 147 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 148 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 149 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 42:
/* rule 42 can match eol */
YY_RULE_SETUP
#line 150 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 43:
/* rule 43 can match eol */
YY_RULE_SETUP
#line 154 "lexer.l"

	YY_BREAK
case 44:
YY_RULE_SETUP
#line 155 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 45:
/* rule 45 can match eol */
YY_RULE_SETUP
#line 158 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 46:
/* rule 46 can match eol */
YY_RULE_SETUP
#line 160 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 47:
/* rule 47 can match eol */
YY_RULE_SETUP
#line 162 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
#line 164 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 166 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 50:
/* rule 50 can match eol */
YY_RULE_SETUP
#line 168 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 170 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 171 "lexer.l"
{
				  yylval.s = strdup(yytext); return PROPFILT; }
	YY_BREAK
case 53:
YY_RULE_SETUP
#line 173 "lexer.l"
{ yylval.s = strdup(yytext); return PRIFILT; }
	YY_BREAK
case 54:
#line 175 "lexer.l"
case 55:
#line 176 "lexer.l"
case 56:
/* rule 56 can match eol */
#line 177 "lexer.l"
case 57:
/* rule 57 can match eol */
#line 178 "lexer.l"
case 58:
/* rule 58 can match eol */
#line 179 "lexer.l"
case 59:
/* rule 59 can match eol */
#line 180 "lexer.l"
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 180 "lexer.l"
{ yylval.s = strdup(yytext);
				  dbgprintf("lex: LEGA ACT: '%s'\n", yytext);
				  return LEGACY_ACTION; }
	YY_BREAK
case 61:
YY_RULE_SETUP
#line 183 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 62:
YY_RULE_SETUP
#line 184 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 63:
YY_RULE_SETUP
#line 186 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 187 "lexer.l"
{
				  yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 190 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 66:
YY_RULE_SETUP
#line 191 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 67:
YY_RULE_SETUP
#line 192 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 68:
YY_RULE_SETUP
#line 193 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 194 "lexer.l"

	YY_BREAK
case 70:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 195 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 196 "lexer.l"

	YY_BREAK
case 72:
YY_RULE_SETUP
#line 197 "lexer.l"
{ dbgprintf("INOBJ: invalid char '%s'\n", yytext); }
	YY_BREAK
case 73:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 198 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  yylval.s = strdup(yytext);
					  return CFSYSLINE;
				  }
				}
	YY_BREAK
case 74:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 210 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 75:
/* rule 75 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 211 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 76:
/* rule 76 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 212 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 77:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 213 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 214 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 215 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 80:
YY_RULE_SETUP
#line 216 "lexer.l"
{ dbgprintf("invalid char: %s\n", yytext);
				}
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(EXPR):
#line 218 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 220 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2091 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 387 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 387 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 386);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 220 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL)
		return 1; /* all processed */
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

